'use strict';
var Example = require('./inheritance.js');

var grumpyCat = new Example.Feline();
grumpyCat.walk('1 meter', 'north');

var coralReef = new Example.LivingBeing();
coralReef.move('1 meter', 'south');

var blue = new Example.Parrot();
blue.fly('1 Km', 'east');

function printPrototypeChain(name, object)
{
	console.log('Prototype chain:\n');
	var prototypeObject = Object.getPrototypeOf(object);
	do {
		console.log('--');
		Object.getOwnPropertyNames(prototypeObject).forEach(function(propertyName, idx, array) {
			console.log(propertyName + ' -> ' + prototypeObject[propertyName]);
		});
		prototypeObject = Object.getPrototypeOf(prototypeObject);
	} while (prototypeObject !== null);
	console.log('\n');
}

/**
 * Let's just print the entire prototype chain
 */
printPrototypeChain('LivingBeing', coralReef);
printPrototypeChain('Feline', grumpyCat);
printPrototypeChain('Parrot', blue);